config/routes.rb
Rails.application.routes.draw do

  namespace :admin do
    resources :bookings
  end
	root to: 'home#index'
	resources :bookings
  get '/donwload_invoice', controller: 'bookings', action: 'donwload_invoice'
	get '/admin/reports', controller: 'admin/bookings', action: 'reports', as: :admin_reports
  # devise_for :users
  Rails.application.routes.draw do
    devise_for :users, controllers: {
      sessions: 'users/sessions'
    }
  end

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/booked_seat.rb
class BookedSeat < ApplicationRecord
	belongs_to :booking
	belongs_to :seat
end

app/models/booking.rb
class Booking < ApplicationRecord
	belongs_to :show
	belongs_to :movie
	belongs_to :customer , :class_name => 'User'
	has_many :booked_seats

	def total_amount
		self.booked_seats.map{|booked_seat|booked_seat.seat.row.screen.price}.sum
	end
	
end

app/models/movie.rb
class Movie < ApplicationRecord
	serialize :star_casts, Hash
	mount_uploader :banner, BannerUploader

	has_many :shows
end

app/models/row.rb
class Row < ApplicationRecord
	belongs_to :screen
	has_many :seats
end

app/models/screen.rb
class Screen < ApplicationRecord
	has_many :rows

	belongs_to :theatre
	has_many :rows
end

app/models/seat.rb
class Seat < ApplicationRecord
	belongs_to :row
	belongs_to :seat_type
end

app/models/seat_type.rb
class SeatType < ApplicationRecord
	belongs_to :theatre
	has_many :seats
end

app/models/show.rb
class Show < ApplicationRecord
	belongs_to :movie
	belongs_to :time_slot
end

app/models/theatre.rb
class Theatre < ApplicationRecord
	has_many :seat_types
	has_many :time_slots
	has_many :screens
end

app/models/time_slot.rb
class TimeSlot < ApplicationRecord
	belongs_to :theatre
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  has_many :bookings, foreign_key: :customer_id

  after_create :set_role

  def set_role
    self.update_column('role', 'Customer') if self.role != 'Admin'
  end

   def admin?
   	 role == 'Admin'
   end

   def customer?
   		role == 'Customer'
   end
end

app/controllers/admin/bookings_controller.rb
class Admin::BookingsController < ApplicationController
  before_action :authenticate_user!

  def index
	@bookings = Booking.order('created_at desc').includes(:show, :movie, :customer, {:booked_seats => {:seat => {:row => :screen}} })
  end
  
  def reports
  	if params[:date].present?
  		date = params[:date].to_date
  		@bookings = Booking.where('booking_for_date = ?', date).order('created_at desc').includes(:show, :movie, :customer, {:booked_seats => {:seat => {:row => :screen}} })
  	end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
	protected  
  def after_sign_in_path_for(resource)
  	if current_user.admin?
		  admin_bookings_path
		 else
		  root_path
		 end
  end
end

app/controllers/bookings_controller.rb
class BookingsController < ApplicationController
  before_action :authenticate_user!
  before_action :set_movie, only: [:index, :create]

  def index
    if params[:step] == '2'
      @shows = @movie.shows.where(date: params[:date].to_date)
      @screens = Theatre.last.screens.order('price ASC').includes(:rows => :seats)
      get_available_seats
    else
      @shows = @movie.shows.group_by{|e|e.date}
    end
    respond_to do |format|
      format.html
      format.js
    end
  end
  
  def get_available_seats
    booking_date = params[:date].to_date
    time_slot_id = params[:ts_id]
    show = @movie.shows.where(time_slot_id: params[:ts_id], date: params[:date].to_date).last
    @bookings = Booking.where(movie_id: @movie.id, booking_for_date: booking_date, show_id: show.id).includes(:movie, :booked_seats)
    @booked_seats = []
    if @bookings.present?
      @bookings.each do |booking|
        booking.booked_seats.each do |seat|
          @booked_seats << seat.seat_id
        end
      end
    end
  end

  def new

  end

  def create
    if check_valid_booking
      show = @movie.shows.where(time_slot_id: params[:time_slot_id], date: params[:booking_for_date].to_date).last
      @booking = Booking.create(
                      movie_id: @movie.id,
                      show_id: show.id,
                      booking_for_date: params[:booking_for_date].to_date,
                      customer_id: current_user.id,
                    )
      params[:seat_numbers].split(',').each do |seat_id|
        @booking.booked_seats.create(seat_id: seat_id)
      end
    else
      @cant_book = true
      @err_msg = "Sorry can't book, some of the seats just got booked. Please choose other seats."
    end  
    respond_to do |format|
      format.js
    end
  end

  def show
    @booking = Booking.find(params[:id])
    @movie = @booking.movie
  end

  def check_valid_booking
    true
  end

  def edit

  end

  def update

  end

  def destroy

  end

  def donwload_invoice
    @booking = Booking.find(params[:id])
    @movie = @booking.movie
    respond_to do |format|
      format.html
      format.pdf do
       render pdf: "#{@movie.name.downcase}-invoice",
       template: "bookings/invoice.pdf.erb",
       :disposition => 'attachment',
       layout: nil
     end
    end
  end

  private

  def set_movie
    @movie = Movie.find(params[:id])
  end

end

app/controllers/home_controller.rb
class HomeController < ApplicationController
	def index
		@movies = Movie.all		
	end
end

app/controllers/users/sessions_controller.rb
# frozen_string_literal: true

class Users::SessionsController < Devise::SessionsController
  layout 'devise'
  # before_action :configure_sign_in_params, only: [:create]

  # GET /resource/sign_in
  # def new
  #   super
  # end

  # POST /resource/sign_in
  # def create
  #   super
  # end

  # DELETE /resource/sign_out
  # def destroy
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_in_params
  #   devise_parameter_sanitizer.permit(:sign_in, keys: [:attribute])
  # end
end

app/controllers/users/unlocks_controller.rb
# frozen_string_literal: true

class Users::UnlocksController < Devise::UnlocksController
  # GET /resource/unlock/new
  # def new
  #   super
  # end

  # POST /resource/unlock
  # def create
  #   super
  # end

  # GET /resource/unlock?unlock_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after sending unlock password instructions
  # def after_sending_unlock_instructions_path_for(resource)
  #   super(resource)
  # end

  # The path used after unlocking the resource
  # def after_unlock_path_for(resource)
  #   super(resource)
  # end
end

app/helpers/admin/bookings_helper.rb
module Admin::BookingsHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
	def get_qr_code
    require 'rqrcode'
    qrcode = RQRCode::QRCode.new("http://github.com/")
    png = qrcode.as_png(
      color_mode: ChunkyPNG::COLOR_GRAYSCALE,
      color: 'black',
      size: 325    
    )
  end
end

app/helpers/bookings_helper.rb
module BookingsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/views/home/index.html.erb
<!-- First Row [Prosucts]-->
<div class="home-page-wrapper">

  <h2 class="font-weight-bold mb-2">Metro Junction Multiplex</h2>
  <p class="font-italic text-muted mb-4">Refresh your mood by watching Hollywood & Bollywood movies.</p>
  
  
  <% @movies.all.each_slice(4) do |movies| %>
    <div class="row pb-5 mb-4">
      <% movies.each_with_index do |movie, index| %>
        <div class="col-lg-3 col-md-6 mb-4 mb-lg-0">
          <!-- Card-->
          <div class="card rounded shadow-sm border-0">
            <div class="card-body p-4">
              <div class="img-wrapper position-relative">
                <img src="<%= movie.banner.path.split('public').last rescue nil %>" alt=""
                  class="img-fluid d-block mx-auto mb-3">
                <a href="<%= bookings_path(id: movie.id)%>" class="hidden-link"></a>
              </div>
              <h5> <a href="#" class="text-dark">
                  <%= movie.name.titleize %>
                </a></h5>
              <p class="small text-muted font-italic">
                <%= movie.description.truncate(40) %>
              </p>
              <ul class="list-inline small">
                <li class="list-inline-item m-0"><i class="fa fa-star text-success"></i></li>
                <li class="list-inline-item m-0"><i class="fa fa-star text-success"></i></li>
                <li class="list-inline-item m-0"><i class="fa fa-star text-success"></i></li>
                <li class="list-inline-item m-0"><i class="fa fa-star text-success"></i></li>
                <% if index%2==0 %>
                  <li class="list-inline-item m-0"><i class="fa fa-star text-success"></i></li>
                  <% else %>
                    <li class="list-inline-item m-0"><i class="fa fa-star-o text-success"></i></li>
                    <% end %>
              </ul>
              <div class="row">
                <div class="col-md-12">
                  <%= link_to "Book Ticket" , bookings_path(id: movie.id), :class=> 'btn btn-sm btn-primary' %>
                </div>
              </div>
            </div>
          </div>
        </div>
        <% end %>
  
    </div>
    <% end %>
</div>